// Iclass.h
//
// header for Iclass.cc
//
// copyright 1998, by Thomas Weldon,
// allrights reserved
//
//
//
// Students in eegr6118 may make copies and modify them 
//for the purposes of their course  projects during spring 1996.
//Any other use of this file is prohibited.
//


#ifndef _Iclass_h

#define _Iclass_h 1


#include <stdlib.h>
#include <limits.h>
#include <iostream.h>
#include <new.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>


class Iclass
{

private:
	int Ixdim;		//dimensions of image
	int Iydim;
	unsigned char *Iarray;	//pointer to first data (unsigned char)
 	char *Iname;		//name of image

public:
	Iclass();	//default constructor
	Iclass(int, int);			//partial constructor
	~Iclass();			//destructor
	Iclass(Iclass&);			// copy constructor
	static void newerr(void) 
		{cout << "Iclass.newerr not enough memory " << "\n";exit(1);}


//GET DATA FROM OBJECT

	char *name()			//return name
		{return Iname;}
	unsigned char getel(int , int );	//get element of array
	int getxdim()
		{return Ixdim;}
	int getydim()
		{return Iydim;}
	unsigned char * getiarray()
		{return Iarray;}


//LOAD DATA INTO OBJECT

	void setel(int , int , unsigned char);	//set element of array

//OPERATORS

	Iclass& operator=(Iclass&);  	//overloaded equal
	Iclass operator+(int);		//element adition	
	Iclass operator+(Iclass&);		//element by element sum	


//IO
	void loadimage( char *); 	//load image from file
	void writeimage( char *); 	//save image to file
	void dplus(int xx, int yy, unsigned char g); 	//draw a plus in the image

//
// add your functions below here 



};

#endif


